const Pokemon = require("../models/pokemon.model.js");

exports.create = (req, res) => {
    // Validate request
    if (!req.body) {
      res.status(400).send({
        message: "Content can not be empty!"
      });
    }
  
    // Create a team pokemon
    const pokemon = new Pokemon({
        id_pokemon : req.body.id_pokemon,
        id_joueur : req.session.uid,
        courant : 1
    });
  
    // add pokemon to team in the database
    Pokemon.create(pokemon, (err, data) => {
      if (err)
        res.status(500).send({
          message:
            err.message || "Some error occurred while creating the Pokemon."
        });
      else res.send(data);
    });
};

exports.findAll = (req, res) => {
    Pokemon.getAll((err, data) => {
      if (err)
        res.status(500).send({
          message:
            err.message || "Some error occurred while retrieving Pokemon."
        });
      else res.send(data);
    });
};

exports.getTeam = (req, res) => {
  console.log("Is logged in: " + req.session.loggedIn);
  if(req.session.loggedIn){
    Pokemon.getTeam(req.session.uid, (err, data) => {
      if (err) {
        if (err.kind === "not_found") {
          res.send({res: true, body: data});
        } else {
          res.status(500).send({
            message: "Error retrieving Team with id " + req.session.uid
          });
        }
      } else{
        res.send({res: true, body: data});
      }
    });
  } else{
    res.send({res: false, body:'You must be logged in to manage a team !'});
    res.end();
  }
};


exports.remove = (req, res) => {
  Pokemon.remove(req.session.uid ,req.body.id_pokemon, (err, data) => {
    if (err) {
      if (err.kind === "not_found") {
        res.status(404).send({
          message: `Not found Team with user id ${req.session.uid} and Pokemon id ${req.body.id_pokemon}`
        });
      } else {
        res.status(500).send({
          message: "Could not delete Pokemon from team with user id " + req.session.uid + " and Pokemon id " + req.body.id_pokemon
        });
      }
    } else res.send({ message: `Pokemon was deleted successfully from Team!` });
  });
};
