const sql = require("./db.js");

// constructor
const Pokemon = function(pokemon) {
  this.id_pokemon = pokemon.id_pokemon;
  this.id_joueur = pokemon.id_joueur;
  this.courant = pokemon.courant;
};


Pokemon.getAll = result => {
    sql.query("SELECT * FROM pokemon", (err, res) => {
      if (err) {
        console.log("error: ", err);
        result(null, err);
        return;
      }
  
      console.log("all good, here is the first Pokemon: ", res[0]);
      result(null, res);
    });
};


Pokemon.getTeam = (joueur_id, result) => {
    sql.query('SELECT p.* FROM pokemon as p, team WHERE id_joueur= ? AND p.id_pokemon=team.id_pokemon', [joueur_id], (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(err, null);
            return;
        }
    
        if (res.length) {
            console.log("found team: ", res);
            result(null, res);
            return;
        }
    
        // not found team with the id
        result({ kind: "not_found" }, null);
    });
};



Pokemon.create = (newPokemon, result) => {
    sql.query('INSERT INTO team SET ?', newPokemon, (err, res) => {
        if (err) {
        console.log("error: ", err);
        result(err, null);
        return;
        }

        console.log("added new Pokemon to team: ", { id: res.insertId, ...newPokemon });
        result(null, { id: res.insertId, ...newPokemon });
    });
};


Pokemon.remove = (id_joueur, id_pokemon, result) => {
    sql.query('DELETE FROM team WHERE id_joueur= ? AND id_pokemon= ? LIMIT 1', [id_joueur, id_pokemon], (err, res) => {
      if (err) {
        console.log("error: ", err);
        result(null, err);
        return;
      }
  
      if (res.affectedRows == 0) {
        // not found team Pokemon with the id
        result({ kind: "not_found" }, null);
        return;
      }
  
      console.log("deleted Pokemon with id: ", id_pokemon, "from team of user with id: ", id_joueur);
      result(null, res);
    });
};

module.exports = Pokemon;