const socketIO = require('socket.io')
module.exports.listen = function(app) {
    var connectedUsers = [];
    var usersMap = new Map();
    const io = socketIO.listen(app)
    var numUsers = 0;
    io.on('connection', socket => {
        console.log('New client connected')
        var addedUser = false;


        socket.on('add user', (username) => {
            if (addedUser) return;
            console.log(username);
            // we store the username in the socket session for this client
            socket.username = username;
            ++numUsers;
            addedUser = true;
            connectedUsers.push(username);
            usersMap.set(username, socket.id)
            
            // echo globally (all clients) that a person has connected
            io.emit('user joined', {
                username: username,
                numUsers: numUsers
            });
        });

        socket.on('get active users', (pseudo) =>{
            var temp = [];
            connectedUsers.forEach(user => {if(user != pseudo) temp.push(user);});
            io.to(socket.id).emit('send list', temp);
        });

        socket.on('new-message', (message) => {
            io.emit('message', { text: message });
            console.log(message);
        });

        socket.on('disconnect', () => {
            console.log('user disconnected')
        });

        socket.on('battle me', (challenger, guest) => {
            console.log(challenger + " " + guest + " " + usersMap.get(guest));
            io.to(usersMap.get(guest)).emit('demande combat', challenger);
        })
    });
};