import { Component, OnInit } from '@angular/core';
import { ChatService } from '../chat.service';
import { HttpClient } from '@angular/common/http';
import { __assign } from 'tslib';

@Component({
  selector: 'app-battle-menu',
  templateUrl: './battle-menu.component.html',
  styleUrls: ['./battle-menu.component.css']
})
export class BattleMenuComponent implements OnInit {

  user: string;
  users: any = [];
  pseudo: string;
  loggedIn: boolean;
  challenges: any = []

  constructor(private chatService : ChatService, private http: HttpClient){}
  
  ngOnInit() {
    this.http.get('http://localhost:3000/checkLogin', { responseType: 'json', withCredentials: true}).subscribe(res => {
      var temp : any = res;
      this.loggedIn = temp.res;
      this.pseudo = temp.body;
      console.log(res);
      if(this.loggedIn){
        this.initiateSockets();
      }else{
        console.log("not logged in");
      }
    });  
  }

  initiateSockets(){
    this.chatService.notify(this.pseudo);
    this.chatService.getNewUsers().subscribe((message: string) => { 
      if(message != this.pseudo) this.users.push(message);
    });
    this.chatService.recevoirListe(this.pseudo).subscribe((liste: string[]) =>{
      this.users = liste;
      console.log(liste);
    });
    this.chatService.recevoirChallenge().subscribe((challenger: string) =>{
      this.challenges.push(challenger);
      console.log("challenges " + this.challenges);
    });
  }

  sendMessage() { 
    this.chatService.sendMessage(this.user);
    this.user = '';
  }

  challenge(user){
    this.chatService.attaquer(this.pseudo, user);
    console.log("sending challenge");
  }

}
