import * as io from 'socket.io-client';
import { Observable } from 'rxjs/Observable';

export class ChatService {

  private url = 'http://localhost:3000';
  private socket;
  
  constructor() {this.socket = io(this.url);}

  public sendMessage(message) {this.socket.emit('new-message', message);}

  public getNewUsers() {
    let observable = new Observable(observer => { 
      this.socket.on('message', (data) => {
        observer.next(data.text); 
      });
      this.socket.on('user joined', (data) => {
        console.log(data.username + ' joined');
        observer.next(data.username);
      });
      return () => {this.socket.disconnect();}; 
    })
    return observable;
  } 

  public notify(pseudo) {
    this.socket.emit('add user', pseudo);
  }

  public attaquer(challenger, guest){ 
    this.socket.emit('battle me', challenger, guest);
    console.log("challenge sent");
  }

  public recevoirChallenge(){
    let observable = new Observable(observer => { 
      this.socket.on('demande combat', (data) => {
        console.log("demande de combat " + data);
        observer.next(data);
      });
      return () => {this.socket.disconnect();}; 
    })
    return observable;
  }

  public recevoirListe(pseudo){
    this.socket.emit('get active users', pseudo);
    let observable = new Observable(observer => { 
      this.socket.on('send list', (data) => {
        console.log("received list" + data);
        observer.next(data);
      });
      return () => {this.socket.disconnect();}; 
    })
    return observable;
  }

}
